#! /usr/bin/perl -w

use strict;

use ExtUtils::testlib;

use MIME::Base64;

use Authen::SPNEGO::GSSAPI qw(gssapi_token_2_read_handle gss_buffer_desc_length hr_errormessage gss_context_time GSS_C_NO_CONTEXT gss_display_status_GSS_CODE gss_display_status_MECH_CODE GSS_S_COMPLETE  gss_import_name major_status_fields);

use MIME::Base64;

#Authen::SPNEGO::GSSAPI::enable_internal_debuggig();

my $nocontext = GSS_C_NO_CONTEXT;

my $s = 'HTTP/moerbsen.grolmsnet.lan';
my ($majorstate, $minorstate, $gss_servername ) = gss_import_name( $s );
unless ($majorstate) {
   ($majorstate, $minorstate, my $sec_context, my $output_token ) = Authen::SPNEGO::GSSAPI::achim_gss_init_sec_context($gss_servername, $nocontext);
   unless ( $majorstate ) {
      my $secs;
      ($majorstate, $minorstate, $secs) =  gss_context_time( $sec_context );
      unless ( $majorstate  ) {
           print "\n Security Context TTL: $secs seconds to live";
      } else {
           print "Error";
      }
      #---------------------------------------------------------------
      # Example1: Write Token base64 encoded to Standardoutput
      #
      print "\n\n Tokenlength is", gss_buffer_desc_length( $output_token );
      print "\n\n Base64 encoded Token is \n\n";
      *HAND = gssapi_token_2_read_handle($output_token );
      #binmode HAND;
      my $temp = $/;
      local($/) = undef;  # slurp
      print encode_base64(<HAND>);
      close HAND;

      #---------------------------------------------------------------
      # Example2: Dump token to file /tmp/token2
      #
      open AUSGABE, '>/tmp/token2' or die "open $!";
      binmode AUSGABE;
      Authen::SPNEGO::GSSAPI::__dump_token2stream( *AUSGABE, $output_token );
      close AUSGABE || die $!;
}

}


if ( $majorstate ) {
  print join "\n", '-----',
                   hr_errormessage( $majorstate, $minorstate),
		   '-----';
}

