#! /usr/bin/perl -w

use strict;

use ExtUtils::testlib;

use Authen::SPNEGO::GSSAPI qw(:all);
use Test::Simple tests => 5;


print "\n OK, let's do some tests of the crappy Software...\n\n";

#if (krb5_available()) {
#  print "\n KeberosV5 Mechtypa avialable, that's good...";
#}

my $s = 'HTTP/moerbsen.grolmsnet.lan';


ok( ref array_gss_indicate_mechs() eq 'ARRAY', 'MechtypeOID Exploration basic' );
ok( @{array_gss_indicate_mechs() } > 0, 'more then 0 Mechtypes available' );
ok( show_all_mech_oids() , 'List Mechtype OIDS' );
ok( krb5_available(), 'KerberosV5 Support available in your GSSAPI' );
ok( check_build_gssname() == GSS_S_COMPLETE, 'gss_import_name( $s )' );



#-------------------------------------------------------
sub check_build_gssname {
    my ($majorstate, $minorstate, $gss_servername ) = gss_import_name( $s );
    return $majorstate;
}
#-------------------------------------------------------
sub show_all_mech_oids {
   eval {
       my @mechs = array_gss_indicate_mechs();
       print "Available Mechtype OIDS:\n";
       foreach (@mechs) {
          print "\n";
          print hr_mechtype(@{$_});
       }
       print "\n";
   };
   $@ ? return 0 : return 1;
}